// 纯大写字母/纯数字/大写字母+数字 校验
jQuery.validator.addMethod(
    "wordAndNumber",
    function(value, element, param) {
    	if(value!=""){
	    	var regu = "^[A-Z0-9_]+$";
	    	var re = new RegExp(regu);
	    	return re.test(value);
    	}else{
    		return true;
    	}
    },
    $.validator.format("请确保输入的值为大写字母、数字或字母与数字组合")
);
$.extend($.fn.validatebox.defaults.rules, {
	wordAndNumber: {
        validator: function(value,param){
        	if(value!=""){
    	    	var regu = "^[A-Z0-9_]+$";
    	    	var re = new RegExp(regu);
    	    	return re.test(value);
        	}else{
        		return true;
        	}
        },
        message: '请确保输入的值为大写字母、数字或字母与数字组合'
    },
    model: {
        validator: function(value,param){
        	if(value=="单体" || value=="模块"){
    	    	return true;
        	}else{
        		return false;
        	}
        },
        message: '请确保输入"单体"或"模块"'
    },
    pack: {
        validator: function(value,param){
        	if(value=="包" || value=="模块"){
    	    	return true;
        	}else{
        		return false;
        	}
        },
        message: '请确保输入"模块"或"包"'
    }
});
var AddApp = function () {
	var tbIdx=0;
	var init=function(data){
		//初始化
        $.ajax({
			url:addr+'/encoding/initAPP',
			type:'post',
			dataType:'json',
			success:function(result){
				initInfo(result);
				//申报表格显示
				$('input[name="showTabs"]').on("click", function(){
					if($(this)[0].value=="1"){
						if($(this)[0].checked){
							$('#tabLi1').show();
							$('#tabLi1').attr("class","active");
							$('#tab1').attr("class","tab-pane active");
							$('#tabLi2').removeAttr("class");
							$('#tab2').attr("class","tab-pane");
						}else{
							$('#tabLi1').hide();
							$('#tab1').attr("class","tab-pane");
						}
					}
					if($(this)[0].value=="2"){
						if($(this)[0].checked){
							$('#tabLi2').show();
							$('#tabLi2').attr("class","active");
							$('#tab2').attr("class","tab-pane active");
							$('#tabLi1').removeAttr("class");
							$('#tab1').attr("class","tab-pane");
						}else{
							$('#tabLi2').hide();
							$('#tab2').attr("class","tab-pane");
						}
					}

			        return true;
				});
				//初始化6-7表格
				var editTableInit = new EditTableInit();
				editTableInit.InitTypeTable("typeTable13",$('#ruleId61').val(),3,1);
				var index=0;
				for(let p=1;p<3;p++){
					for(let q=1;q<4;q++){
						//添加校验
						  $('#toolbar4'+p+q).validate({
							    rules: {
							    	typeDes: {
							    		minlength: 2,
							    		maxlength:2,
							    		wordAndNumber:true
							    	}
							    }
						  });
						  //添加按钮事件
						$('#addTypeBtn'+p+q).on("click", function(){
							addTypeRow(p,q);
					    });
					}
				}
				$("#tabs ul li a").on("shown.bs.tab", function(e){
					if($(e.target).attr("href")=="#tab2"){
						if($('#typeTable23')[0].classList.length==0){
							editTableInit.InitTypeTable("typeTable23",$('#ruleId62').val(),3,2);
						}
					}
				});
				//初始化第二个6-7表格
				for(var i=1;i<3;i++){
					for(var j=1;j<4;j++){
						editTableInit.InitTypeTable("typeTable"+i+j,$('#ruleId6'+i).val(),j,i);
					}
				}


				//提交按钮
				$('#submitBtn').on("click", function(){
					$('#submitBtn').attr("disabled","disabled");
					var map={};
					map["appTime"]=$('#appTime').val();
					map["enterpriseIsCascade"]=$('input[name="isCascade"]:checked').val();
					let tabArr=$('input[name="showTabs"]:checked');
					for(let k=0;k<tabArr.length;k++){
						if(tabArr[k].value=="1"){//非梯级
							//4
							var rowList1=new Array();
							var rows41=$('#productTypeTab input[name="productType"]:checked');
							for(let i=0;i<rows41.length;i++){
								var item=new Object();
								item.valueCode=$(rows41[i]).val();
								item.valueDescription=$(rows41[i]).attr('des');
								item.appRuleId=$('#ruleId41').val();
								rowList1.push(item);
							}
							map["ncrow4"]=rowList1;
							//6校验
							for(let l=1;l<4;l++){
								if($('#typeTable1'+l)[0].classList.length!=0){
									var rows=$('#typeTable1'+l+' tr');
									for(let p=1;p<rows.length;p++){
										if(typeof($(rows[p]).attr("childcount"))=="undefinded" || $(rows[p]).attr("childcount")==0){
											layer.msg("请补全X6-7位详细内容!");
											$('#submitBtn').removeAttr("disabled");
											return ;
										}
									}
								}
							}
							if($('#x8selectBegin').val()!=null || $('#x8selectEnd').val()!=null)
							{
								layer.msg("请补全X8-14位规则说明!");
								$('#submitBtn').removeAttr("disabled");
								return ;
							}

							var rowList2=new Array();
							if(divArr.length>1){
								for(var i=1;i<divArr.length;i++){
									var index = divArr[i];
									var rows = $("#x8table"+index).datagrid('getRows');
									for(var j=0;j<rows.length;j++){
										var idx=$("#x8table"+index).datagrid('getRowIndex',rows[j]);
										if($("#x8table"+index).datagrid('validateRow',j)==false){
											layer.msg("请按提示修改表单!");
											$('#submitBtn').removeAttr("disabled");
											return ;
										}
										$("#x8table"+index).datagrid('endEdit',j);
										rows[j].appRuleId=$('#ruleId81'+index).val();
										rowList2.push(rows[j]);
									}
								}
							}
							map["row8"]=rowList2;
						}else if(tabArr[k].value=="2"){//梯级
							//4
							var rowList3=new Array();
							var rows42=$('#productTypeTab2 input[name="productType"]:checked');
							for(let i=0;i<rows42.length;i++){
								var item=new Object();
								item.valueCode=$(rows42[i]).val();
								item.valueDescription=$(rows42[i]).attr('des');
								item.appRuleId=$('#ruleId42').val();
								rowList3.push(item);
							}
							map["crow4"]=rowList3;
							//6校验
							for(let l=1;l<4;l++){
								if($('#typeTable2'+l)[0].classList.length!=0){
									var rows=$('#typeTable2'+l+' tr');
									for(let p=1;p<rows.length;p++){
										if(typeof($(rows[p]).attr("childcount"))=="undefined" || $(rows[p]).attr("childcount")==0){
											layer.msg("请补全X6-7位详细内容!");
											$('#submitBtn').removeAttr("disabled");
											return ;
										}
									}
								}
							}
						}
					}
					var loading = layer.load(1, {
						  shade: [0.5,'#fff'] //0.1透明度的白色背景
						});

					$.ajax({
						url:addr+'/encoding/submitApp',
						type:'post',
						data: JSON.stringify(map),//将对象序列化成JSON字符串
					    dataType:"json",
					    contentType : 'application/json;charset=utf-8', //设置请求头信息
						success:function(result){
							$('#submitBtn').removeAttr("disabled");
							layer.close(loading);
							if(result.status==0){
								layer.msg("备案申请提交成功!等待中机审核！");
								//进入查看页
								toDetail($('#enterprise_ID').val());
							}else{
								layer.msg("提交失败!");
							}
						}
					});
			    });
			}
		});
	};
	//跳转查看
	var toDetail = function(id){
		$("#mainContents").empty();
        $.ajax({
            type: "GET",
            url: "application/encode/detail_app.html",
            success: function (data) {
            	var html = data.replace("forReplace","<input id='enterpriseId' type='hidden' value='"+id+"'>");
                $("#mainContents").html(html);
            }
        });
	}
	//填写表单
	function initInfo(data){
		//企业信息
		if(data.enterprise!=null){
			$('#enterprise_ID').val(data.enterprise.enterprise_ID);
			$('#enterprise_NAME_ZN').html(data.enterprise.enterprise_NAME_ZN);
			$('#register_ADDR').html(data.enterprise.register_ADDR);
			$('#production_ADDR').html(data.enterprise.production_ADDR);
			$('#enterprise_CODE').text(data.enterprise.enterprise_CODE);
			$('#enterprise_CODE2').text(data.enterprise.enterprise_CODE);
		}
		if(data.ncBasicEO!=null){
			$('#ncBasicId').val(data.ncBasicEO.appRuleId);
			$('#isCascade').val(data.ncBasicEO.appRuleId);

			if(data.ncBasicEO.appTime!=null){
				$('#appTime').val(data.ncBasicEO.appTime);
			}else{
				var today=new Date();
				$('#appTime').val(today.getFullYear()+"-"+(today.getMonth()+1)+"-"+today.getDate());
			}


			$('#appTime').datetimepicker({
			    format: 'yyyy-mm-dd',
			    minView:2,
			    todayHighlight:true
			});
			if(data.ncBasicEO.enterprisIsCascaded=="1"){
				$('#yes').prop("checked","checked");
			}else{
				$('#no').prop("checked","checked");
			}
		}
		if(data.cBasicEO!=null){
			$('#cBasicId').val(data.cBasicEO.appRuleId);
		}
		//初始化规则信息
		if(data.ncRules!=null && data.ncRules.length>0){
			for(var i=0;i<data.ncRules.length;i++){
				var rule=data.ncRules[i];
				$('#ruleId'+rule.beginIndex+"1").val(rule.ruleId);
				//初始化8~14
				if(rule.beginIndex==8 && rule.endIndex==14){
					var editTableInit = new EditTableInit();
					editTableInit.InitTranceTable(rule);
				}
			}
			//traceInput
			$("#traceInput").attr("maxLength",10);
		}
		if(data.cRules!=null && data.cRules.length>0){
			for(var i=0;i<data.cRules.length;i++){
				var rule=data.cRules[i];
				$('#ruleId'+rule.beginIndex+"2").val(rule.ruleId);
			}
		}
		if(data.flow!=null&& data.flow.approveOpinion!=null && data.flow.approveOpinion!=""){
			$('#review').show();
			$('#review').html("审批意见:"+data.flow.approveOpinion);
			if(data.flow.approveStatus==1){
				$('#review').attr("class","alert alert-success");
			}else{
				$('#review').attr("class","alert alert-error");
			}
		}
		//产品类型代码
		$.ajax({
			url:addr+"/api/enterprise/dimruleitems/findListByTypeCode",
			type:"POST",
			data:{typeCode:"X4"},
			dataType:"json",
			success:function(result){
				var list = result.data;
				var trs = "<tr><th>代码取值</th><th>取值含义</th></tr>";
				for(var i in list){
					trs += "<tr><td><input name=\"productType\" des=\""+list[i].valueDescription+"\" value=\""+list[i].valueCode+"\" type=\"checkbox\" />"+list[i].valueCode+"</td><td>"+list[i].valueDescription+"</td></tr>";
				}
				$("#productTypeTab").html(trs);
				$("#productTypeTab2").html(trs);
				$('#productTypeTab input[name="productType"]').on("click", function(){
					changeTab('div41',this);
					return true;
				});
				$('#productTypeTab2 input[name="productType"]').on("click", function(){
					changeTab('div42',this);
					return true;
				});
				var map1={P:false,M:false,C:false};
				if(data.ncX4Items!=null){
					for(var j=0;j<data.ncX4Items.length;j++){
						let item= data.ncX4Items[j];
//						$('#productTypeTab input[value="'+item.valueCode+'"]').prop("checked","checked");
						map1[item.valueCode]=true;
					}
				}else{
					map1['P']=true;
					map1['M']=true;
					map1['C']=true;
				}
				for(var key in map1) {
					if(map1[key])
						$('#productTypeTab input[value="'+key+'"]').prop("checked","checked");
				}

				var map2={P:false,M:false,C:false};
				if(data.cX4Items!=null){
					for(var j=0;j<data.cX4Items.length;j++){
						let item= data.cX4Items[j];
//						$('#productTypeTab2 input[value="'+item.valueCode+'"]').prop("checked","checked");
						map2[item.valueCode]=true;
					}
				}else{
					map2['P']=true;
					map2['M']=true;
					map2['C']=true;
				}
				for(var key in map2) {
					if(map2[key])
						$('#productTypeTab2 input[value="'+key+'"]').prop("checked","checked");
				}
			}
		});
	}
	//添加行
	function addTypeRow(tableIdx,type){
		$('#addTypeBtn'+tableIdx+type).attr("class","btn green btn-small unabled");

		if($('#typeDes'+tableIdx+type).val()!=null && $('#typeDes'+tableIdx+type).val()!=""){
			if($('#toolbar4'+tableIdx+type).valid()){
				var item=new Object();
				item.ruleType="6-7";
				item.valueCode=$('#typeDes'+tableIdx+type).val();
				item.typeFlag=type;
				if(tableIdx==1){
					item.basicId=$('#ncBasicId').val();
					item.appRuleId=$('#ruleId61').val();
					item.isCascaded=0;
				}else{
					item.basicId=$('#cBasicId').val();
					item.appRuleId=$('#ruleId62').val();
					item.isCascaded=1;
				}
				$.ajax({
					url:addr+'/encoding/addItem',
					data:item,
					type:'post',
					dataType:'json',
					success:function(result){
						$('#addTypeBtn'+tableIdx+type).attr("class","btn green btn-small");
						$('#typeDes'+tableIdx+type).val("");
						if(result.rulesId!=null){
							if(tableIdx==1)
								$('#ruleId61').val(result.rulesId);
							else
								$('#ruleId62').val(result.rulesId);
						}
					   if(result.itemsEO!=null );
					   {
						   var str="";
						   var parentItem=result.itemsEO;
						   str+=('<tr id="item_'+parentItem.ruleItemId+'" childCount="0"><td>'+parentItem.valueCode+'</td>');
						   str+=('<td><a class="btn btn-mini" data-target="#myModal" '
				                	+'href="javascript:AddApp.showChildrenWin(&quot;'+parentItem.ruleItemId+'&quot;,&quot;'+parentItem.valueDescription+
				                	'&quot;,&quot;'+parentItem.typeFlag+'&quot;,&quot;'+parentItem.appRuleId+'&quot;,'+tableIdx+');">详细</a></td>');
						   str+=('<td><a class="btn green btn-small" href="javascript:AddApp.delItemGroup(&quot;'+parentItem.ruleItemId+'&quot;,&quot;typeTable'+tableIdx+type+'&quot;);"><i class="icon-minus"></i></a></td></tr>');
						   $('#typeTable'+tableIdx+type+" tbody").append(str);
					   }
					}
				});
			}else{
				$('#addTypeBtn'+tableIdx+type).attr("class","btn green btn-small");
			}
		}else{
			layer.msg("请填写代码取值");
			$('#addTypeBtn'+tableIdx+type).attr("class","btn green btn-small");
		}
	}

	//编辑表格创建
	var EditTableInit = function() {
	   var editTable = new Object();
	 //初始化Table
	   editTable.Init=function(tableName,toolBarName){
		   $('#'+tableName).datagrid({
				fitColumns:true,
				columns:[[
			        {field:'value',title:'代码取值',width:100},
			        {field:'description',title:'取之说明',width:100},
			        {
		                field: 'operation',
		                title: '操作',
		                width:100,
		                formatter:function(value,row,index){
		                	return '<a class="btn green btn-mini" href="javascript:void(0);"><i class="icon-plus"></i></a>&nbsp;&nbsp;'+
		                			'<a class="btn btn-danger btn-mini" href="javascript:AddApp.delRow(&quot;typeTable1&quot;,'+row.id+');"><i class="icon-minus"></i></a>';
		                }
		            }
			    ]]
			});
	   };
	 //6-7类型表新增
	   editTable.InitTypeTable=function(tableName,ruleId,typeFlag,tabIndex){
		   $.ajax({
			   url:addr+'/encoding/findX6Items',
			   data:{
				   ruleId: ruleId,
				   typeFlag:typeFlag
			   },
			   type:'post',
			   dataType:'json',
			   success:function(data){
				   $('#'+tableName+" tbody").empty();
				   if(data!=null && data.length>0);
				   {
					   var str="";
					   for(var i=0;i<data.length;i++){
						   var parentItem=data[i];
						   str+=('<tr id="item_'+parentItem.ruleItemId+'" childCount="'+parentItem.childCount+'"><td>'+parentItem.valueCode+'</td>');
						   var className=""
						   if(parentItem.childCount>0){
							   className="green";
		                	}
						   str+=('<td><a class="btn '+className+' btn-mini" data-target="#myModal" '
				                	+'href="javascript:AddApp.showChildrenWin(&quot;'+parentItem.ruleItemId+'&quot;,&quot;'+parentItem.valueDescription+
				                	'&quot;,&quot;'+parentItem.typeFlag+'&quot;,&quot;'+parentItem.appRuleId+'&quot;,'+tabIndex+');">详细</a></td>');
						   str+=('<td><a class="btn green btn-small" href="javascript:AddApp.delItemGroup(&quot;'+parentItem.ruleItemId+'&quot;,&quot;'+tableName+'&quot;);"><i class="icon-minus"></i></a></td></tr>');
					   }
					   $('#'+tableName+" tbody").html(str);
				   }
			   }
		   });
	   };
	   //初始化8-14
	   editTable.InitTranceTable=function(rule){
			$.ajax({
				url:addr+'/encoding/findRules',
				data:{
					basicId:$('#ncBasicId').val(),
					parentId:rule.ruleId
				},
				type:'post',
				dataType:'json',
				success:function(result){
					for(var j=0;j<result.length;j++){
						$('.delItemGroup').hide();
						childRule=result[j];
						let last = divArr[divArr.length-1];
						let newLast = last + 1;
						let x8divnext = "x8div"+newLast;
						let datagridId ="#x8table"+newLast;
						let title = "代码位置  "+childRule.beginIndex+"~"+childRule.endIndex+"&nbsp;&nbsp;"+childRule.description;
						let content = "<div id='"+x8divnext+"' class='greyColor paddingStyle'>" +
										"<table id='x8table"+newLast+"'>" +
										"<input id='ruleId81"+newLast+"' value="+childRule.ruleId+" type='hidden'/>"+
										"<input type='hidden' id='x8hiddenbegin"+newLast+"' value="+childRule.beginIndex+">" +
										"<input type='hidden' id='x8hiddenend"+newLast+"' value="+childRule.endIndex+">" +
										"<input type='hidden' id='x8hiddendesc"+newLast+"' value='"+childRule.description+"'>" +
										"<div id='x8toolbar"+newLast+"'>" +
											"<div class='x8toolbarDiv'><strong>"+title+"</strong>" +
											"&nbsp;&nbsp;&nbsp;&nbsp;<a class='btn green btn-mini' href='javascript:void(0);' onclick='addRow(&quot;"+datagridId+"&quot;)'><i class='icon-plus'></i></a>" +
											"<a class='btn green btn-danger btn-mini floatright delItemGroup' href='javascript:void(0);' onclick='removeDiv(&quot;"+newLast+"&quot;,"+childRule.beginIndex+","+childRule.endIndex+")'><i class='icon-minus'></i> &nbsp;删除</a></div>" +
										"</div>" +
									"</div>";
						$("#x8div"+last).after(content);
						//添加到全局变量
						divArr.push(newLast);
						rangeList.push({beginValue:childRule.beginIndex,endValue:childRule.endIndex});

						let datagrid = $(datagridId);
						let size = childRule.endIndex - childRule.beginIndex + 1;
						$(datagridId).datagrid({
							url:addr+'/encoding/findItems',
						   queryParams: {
							   ruleId: $('#ruleId81'+newLast).val()
						   },
							fitColumns:true,
						    columns:[[
						        {field:'valueCode',title:'代码取值',width:100,editor:{type:'validatebox',options:{required:true,validType:['length['+size+','+size+']','wordAndNumber']}}},
						        {field:'valueDescription',title:'取值含义',width:100,editor:{type:'validatebox',options:{required:true,validType:['length[0,10]']}}},
						        {
					                field: 'id',
					                title: '操作',
					                width:50,
					                halign:'center',
					                align:'center',
					                striped:false,
					                formatter:function(value,row,index){
//					                	return '<a class="btn green btn-mini" href="javascript:void(0);" onclick="confirmRow(&quot;'+datagridId+'&quot;,'+index+')"><i class="icon-ok"></i></a>' +
//					                	'&nbsp;&nbsp;&nbsp;<a class="btn green btn-mini" href="javascript:void(0);" onclick="removeRow(&quot;'+datagridId+'&quot;,'+index+')"><i class="icon-minus"></i></a>';
					                	return '<a class="btn green btn-mini" href="javascript:void(0);" onclick="removeRow(&quot;'+datagridId+'&quot;,'+index+',&quot;'+row.ruleItemId+'&quot;)"><i class="icon-minus"></i></a>';
					                }
					            }
						    ]],
						    toolbar: '#x8toolbar'+newLast,
						    onDblClickRow:function(index,data){
						    	$(datagridId).datagrid('acceptChanges');
						    	$(this).datagrid('beginEdit', index);
						    },

//						    onSelect:function(index,data){
//						    	$(datagridId).datagrid('unselectRow',index);
//						    }
						});
						setBeginSelct();
					}

				}
			});

	   }
	   return editTable;
	};
	//6-7删除节点组
	var delItemGroup=function(parentId,tableName,index){
		if(parentId!=""){
			$.ajax({
				url:addr+'/encoding/delItemGroup',
				type:'post',
				data: {itemId:parentId},
			    dataType:"json",
				success:function(result){
					if(result.status==0){
						layer.msg("删除成功!");
						$('#'+tableName+' #item_'+parentId).remove();
					}else{
						layer.msg("删除失败!");
					}
				}
			});
		}
	};
	//子节点弹窗
	var showChildrenWin=function(parentId,typeCode,type,appRuleId,tabIndex){
		$('#childItem').val("");
		$('#parentItemId').val(parentId);
		$('#typeFlag').val(type);
		$('#appRuleId').val(appRuleId);
		$('#tabIndex').val(tabIndex);
		$('#childItemsTable').datagrid({
			url:addr+'/encoding/findChildItems',
			striped:false,
			fitColumns:true,
		   queryParams: {
			   typeCode: typeCode,
			   ruleId:appRuleId,
			   parentId:parentId,
			   typeFlag:type
		   },
		   toolbar: "#tb",
		   columns:[[
			   {field:'valueDescription',title:'规格代码说明',width:100},
		       {field:'valueCode',title:'规格代码取值',width:100,editor:{
                 type: 'validatebox',
                 options: {
                    editable: true,
                    panelHeight:70,
                    required: true
                }
		       }},
		        {field:'isOperated',title:'操作',width:50,
	                formatter:function(value,row,index){
	                	if(value!=null){
	                		return '<a class="btn btn-mini" href="javascript:AddApp.delChildItem(&quot;'+
	                		row.ruleItemId+'&quot;,'+index+');"><i class="icon-minus"></i></a>';
	                	}
	                }
                }
		    ]],
		    onDblClickRow:function(index,row){
		    	if(row.valueDescription!=null){
		    		$('#childItemsTable').datagrid('beginEdit',index);
		    		if((type=="2" || type=="3") && tabIndex==2){
		    			if(row.valueDescription=="梯级利用产品形式"){
						   var ed = $('#childItemsTable').datagrid('getEditor', {index:index,field:'valueCode'});
						   if(type=="2"){
							   $(ed.target).validatebox({
								   validType:'model'
							   });
						   }else if(type=="3"){
							   $(ed.target).validatebox({
								   validType:'pack'
							   });
						   }
					   }
		    		}

		    	}
		    },
		   onLoadSuccess:function(){
			   $('#win').show();
				var win=$('#win').window({
					title:'详细说明',
				    width:600,
				    height:400,
				    modal:true
				});
				win.window('open');
		   }
		});
	};
	//添加子项
	var addChildItem=function(){
		$('#childItemsTable').datagrid('appendRow',{valueDescription:$('#childItem').val(),isOperated:1});
	 }
	//删除子项
	var delChildItem=function(ruleItemId,index,tabIndex){
		if(ruleItemId!="undefined" && ruleItemId!=""){
			$.ajax({
				url:addr+'/encoding/delItem',
				type:'post',
				data: {ruleItemId:ruleItemId},//将对象序列化成JSON字符串
			    dataType:"json",
//			    contentType : 'application/json;charset=utf-8', //设置请求头信息
				success:function(result){
					if(result.status==0){
						layer.msg("删除成功!");
						$('#childItemsTable').datagrid('deleteRow',index);
					}else{
						layer.msg("删除失败!");
					}
				}
			});
		}else{
			$('#childItemsTable').datagrid('deleteRow',index);
		}
	 };
	//保存所有添加子项
	 var saveChildItems=function(){

		 var rows = $('#childItemsTable').datagrid('getRows');
		//校验
		 if(rows!=null && rows.length>0){
			 for(var i=0;i<rows.length;i++){
				 var idx=$('#childItemsTable').datagrid('getRowIndex',rows[i]);
				 var ed=$('#childItemsTable').datagrid('getEditor', {index:idx,field:'valueCode'});
				 if(ed!=null && !$(ed.target).validatebox('isValid')){
					 layer.msg("请按要求填写内容!");
					 return;
				 }
			 }
		 }

		$('#yesBtn').attr("class","btn green btn-small offset4 unabled ");
//		var rows=$('#childItemsTable').datagrid('getRows');
		for(var i=0;i<rows.length;i++){
			var idx=$('#childItemsTable').datagrid('getRowIndex',rows[i]);
			$('#childItemsTable').datagrid('endEdit',idx);
			rows[i].parentItemId=$('#parentItemId').val();
			rows[i].typeFlag=$('#typeFlag').val();
			rows[i].appRuleId=$('#appRuleId').val();
			delete rows[i].dimItemId;
		}
		$.ajax({
			url:addr+'/encoding/addItems',
			type:'post',
			data: JSON.stringify(rows),//将对象序列化成JSON字符串
		    dataType:"json",
		    contentType : 'application/json;charset=utf-8', //设置请求头信息
			success:function(result){
				$('#yesBtn').attr("class","btn green btn-small offset4");
				let tabIndex=$('#tabIndex').val();
				let type=$('#typeFlag').val();
				if(result.status==0){
					$('#win').window('close');
					layer.msg("添加成功!");
//					$('#typeTable'+tabIndex+type).datagrid('reload');
					var editTableInit=new EditTableInit();
					editTableInit.InitTypeTable("typeTable"+tabIndex+type,$('#ruleId6'+tabIndex).val(),type,tabIndex);
				}else{
					layer.msg("添加失败!");
				}
			}
		});
	 }
	 //删除行
	 var delTypeRow=function(tableName,id){
		   $('#'+tableName).treegrid('remove',id);
	 };
	 //添加行
	 var addTypeChildRow=function(tableName,id){
		 $('#'+tableName).treegrid('acceptChanges');
		 var children=$('#'+tableName).treegrid('getChildren',id);
		 $('#'+tableName).treegrid('append',{parent:id,data:[{"id":id+"_"+children.length,"value":"","description":"","operation":2}] });
		 $('#'+tableName).treegrid('beginEdit',id+"_"+children.length);
	 };

	 var saveTypeRow=function(tableName,id){
		 $('#'+tableName).treegrid('endEdit', id);
	 };

	return {
        init: init,
        delTypeRow:delTypeRow,
        addTypeChildRow:addTypeChildRow,
        saveTypeRow:saveTypeRow,
        showChildrenWin:showChildrenWin,
        addChildItem:addChildItem,
        delChildItem:delChildItem,
        saveChildItems:saveChildItems,
        delItemGroup:delItemGroup
    };
}();
