var ListApp = function () {
	var Init = function (type) {
		let url=addr+'/encode/list';
		
		$('#table').bootstrapTable({
            url: url,         //请求后台的URL（*）
            method: 'post',                      //请求方式（*）
            striped: true,                      //是否显示行间隔色
            cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
            pagination: true,                   //是否显示分页（*）
            queryParams:function (params) {
            	params.enterpriseNameZn= $("#enterpriseNameZn").val();
            	params.legalPerson= $("#legalPerson").val();
            	params.stratTime= $("#stratTime").val();
            	params.endTime= $("#endTime").val();
                return params;
            },//传递参数（*）
            sidePagination: "server",           //分页方式：client客户端分页，server服务端分页（*）
            pageNumber:1,                       //初始化加载第一页，默认第一页
            pageSize: 10,                       //每页的记录行数（*）
            pageList: [10, 25, 50, 100],        //可供选择的每页的行数（*）
            clickToSelect: true,                //是否启用点击选中行
	        height: 500,                        //行高，如果没有设置height属性，表格自动根据记录条数觉得表格高度
            uniqueId: "ENTERPRISE_CODE",                     //每一行的唯一标识，一般为主键列
            columns: [{
		        field: 'ENTERPRISE_CODE',
		        title: 'ENTERPRISE_CODE',
		        visible:false
		    }, {
		        field: 'ENTERPRISE_NAME_ZN',
		        title: '企业名称',
		        width:100
		    }, {
		        field: 'REGISTER_ADDR',
		        title: '企业地址',
		        width:100
		    },{
		        field: 'APPLYTIME',
		        title: '申请日期',
		        width:100
		    },{
		        field: 'PASSTIME',
		        title: '通过日期',
		        width:100
		    },{
		        title: '状态',
		        width:100,
		        formatter:function(){
		        	return '已通过';
		        }
		    },
		    {
		        field: 'name',
		        title: '操作',
		        width:100,
		        formatter:function(value,row,index){
		        	return '<a class="btn btn-mini" href="javascript:ListApp.toDetail(&quot;'+row.ENTERPRISE_ID+'&quot;,&quot;'+row.CHANGE_FLAG+'&quot;);"><i class="icon-list-alt"></i></a>';
		        }
		    }]
        });    
		$('#btnSearch').on('click',function(){
			$("#table").bootstrapTable("refresh",{method:"post"});
		});
	};
	var toDetail = function(id,change){
		$("#mainContents").empty();
        $.ajax({
            type: "GET",
            url: "application/encode/final_detail.html",
            success: function (data) {
            	var html = data.replace("forReplace","<input id='enterpriseId' type='hidden' value='"+id+"'><input id='changeFlag' type='hidden' value='"+change+"'>");
                $("#mainContents").html(html);
            }
        });
	}
	return {
		Init:Init,
		toDetail:toDetail
	};
}();
